// Ex-p5-Audio5-File-Speed
// Pour p5.js (Processing en JavaScript)
// Origine: https://github.com/danielpradilla/p5js_speed_volume
// Utilise: libraries/p5.js
// Utilise: libraries/p5.sound.js

var Voix;

function preload() {
  Voix = loadSound('cemuhi-12s.mp3');
}

function setup() {
  createCanvas(windowWidth, windowHeight);
}

function draw() {
  background(255);
  fill(50, 150, 50);
  noStroke();
  text('Drag the mouse around to rate and amplitude', 20, 20);
  text('Click: Play / Pause', 20, 40);

  // Set the volume to a range between 0 and 1.0
  var volume = map(mouseX, 0, width, 0, 100);
  volume = constrain(volume, 0, 100);
  Voix.amp(volume / 100);
  text('Volume = ' + int(volume), 300, 40);

  // Set the rate to a range between 0.5 and 2
  var speed = map(mouseY, 0.1, height, 200, 50);
  speed = constrain(speed, 50, 200);
  Voix.rate(speed / 100);
  text('Speed (100 = normal) = ' + int(speed), 20, 200);

  // Draw circle and lines to show what is going on
  // fill(51, 100);
  stroke(255, 0, 0);
  line(mouseX, 0, mouseX, height);
  line(0, mouseY, width, mouseY);
  noStroke();
  ellipse(mouseX, mouseY, 48, 48);
}

function mousePressed() {
  if (Voix.isPlaying()) Voix.pause();
  else Voix.play();
}

function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
}